"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
// Angular
var wjcGridSheet = require("wijmo/wijmo.grid.sheet");
var wjcGrid = require("wijmo/wijmo.grid");
var core_1 = require("@angular/core");
var data_service_1 = require("./data.service");
'use strict';
// The Explorer application root component.
var AppComponent = /** @class */ (function () {
    function AppComponent(dataSvc) {
        this.dataSvc = dataSvc;
        this.data = dataSvc.getData(10);
    }
    AppComponent.prototype.flexSheetInit = function (flexSheetIntro) {
        var _this = this;
        var self = this;
        if (flexSheetIntro) {
            flexSheetIntro.deferUpdate(function () {
                flexSheetIntro.selectedSheetIndex = 0;
                flexSheetIntro.selectedSheet.itemsSource = _this.data;
                self._initDataMapForBindingSheet(flexSheetIntro);
            });
        }
    };
    // initialize the dataMap for the bound sheet.
    AppComponent.prototype._initDataMapForBindingSheet = function (flexSheet) {
        var column;
        if (flexSheet) {
            column = flexSheet.columns.getColumn('countryId');
            if (column && !column.dataMap) {
                column.dataMap = this._buildDataMap(this.dataSvc.countries);
            }
            column = flexSheet.columns.getColumn('productId');
            if (column && !column.dataMap) {
                column.dataMap = this._buildDataMap(this.dataSvc.products);
            }
        }
    };
    // build a data map from a string array using the indices as keys
    AppComponent.prototype._buildDataMap = function (items) {
        var map = [];
        for (var i = 0; i < items.length; i++) {
            map.push({ key: i, value: items[i] });
        }
        return new wjcGrid.DataMap(map, 'key', 'value');
    };
    __decorate([
        core_1.ViewChild('flexSheetIntro'),
        __metadata("design:type", wjcGridSheet.FlexSheet)
    ], AppComponent.prototype, "flexSheetIntro", void 0);
    AppComponent = __decorate([
        core_1.Component({
            selector: 'my-app',
            templateUrl: './app.component.html'
        }),
        __param(0, core_1.Inject(data_service_1.DataSvc)),
        __metadata("design:paramtypes", [data_service_1.DataSvc])
    ], AppComponent);
    return AppComponent;
}());
exports.AppComponent = AppComponent;
//# sourceMappingURL=app.component.js.map